/*
    $Id: cdpath.h,v 1.1 2001/02/17 13:54:24 hvr Exp $

    Copyright (C) 2000 Herbert Valerio Riedel <hvr@gnu.org>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef __cdpath_h__
#define __cdpath_h__

#include <glib.h>

/* resets/inits cdpath db */
void cdpath_reset (void);

/* insert record into cdpath db */
void cdpath_set (const gchar pathname[], gint32 uid, gint32 gid, guint32 perm);

/* return FALSE if not found, sets arg ptr's != NULL with found value */
gboolean cdpath_get (const gchar pathname[], gint32 *uid, gint32 *gid, guint32 *perm);

/* returns longest matched key or NULL if none found */
const gchar *cdpath_match (const gchar pathname[]);

#endif /* __cdpath_h__ */
