/*
  $Id: control.h,v 1.1.2.1 2002/10/26 09:55:18 prime Exp $

  Copyright (C) 2000 Herbert Valerio Riedel <hvr@gnu.org>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef __CONTROL_H__
#define __CONTROL_H__

/* control connection stuff... */

#include <glib.h>

/* full command version */
gint send_reply_full (gint code, gboolean terminate, gboolean expand_color,
		      gboolean leading_space, const gchar reply[]);

/* full command version w/ format */
gint send_reply_full_f (gint code, gboolean terminate, gboolean expand_color,
			const gchar fmt[], ...) G_GNUC_PRINTF (4, 5);

/* shortcuts */

#define send_reply(code, reply) \
send_reply_full ((code), TRUE, TRUE, TRUE, (reply))

#define send_reply_raw(code, reply) \
send_reply_full ((code), TRUE, FALSE, TRUE, (reply))

#define send_reply_stat(code, reply) \
send_reply_full ((code), TRUE, FALSE, FALSE, (reply))

#define send_error(code, command, _errno) \
send_reply_full_f (code, TRUE, FALSE, "%s (%s).", g_strerror (_errno), command)

#endif /* __CONTROL_H__ */
