#!/usr/bin/perl -w

###########################################################################
#                                                                         #
# autodel.pl v0.3 - Frees up space till a fixed value is reached by       #
#                   deleting inside multiple subdirs with a bonus system  #
#                                                                         #
###########################################################################
#                                                                         #
# ATTENTION: i suggest that u comment out the rm -Rf line for testing !!! #
#                                                                         #
###########################################################################

use strict;
use primetools;

###########################################################################
### Set to 1 to be verbose or 2, 3 for being even verboser ;)           ###

my $debug = 1;

###                                                                     ###
###########################################################################
### vars for announcing...                                              ###

my $sitename     = "ABC";
my $botpidfile   = "/home/openftpd/etc/pid.eggdrop";
my $announcefile = "/home/openftpd/etc/announce.txt";
my $formatfile   = "/home/openftpd/msg/irc/autodel";

###                                                                     ###
###########################################################################
### Set the bouns system here in days                                   ###
### e.g. dir "DiVX" should get a 10 day bonus and SVCD a 5 day fee      ###

my %bonus = (
	"/home/openftpd/site/DiVX" => 10,
	"/home/openftpd/site/SVCD" => -5
);

my $nukesfee = -15;

###                                                                     ###
###########################################################################


my($dummy);
my(%dirstodel);
my($space, $volume, $dir, $subdir, $time, $df);
my($format, $du, $size, $parentdir, $deleteddir, @rules);


if (($#ARGV<2) or ($ARGV[0] !~ /^\d+$/)) {
	print "USAGE: ./autodel.pl <freespace> <volume> <dir> [dir2 dir3...]\n";
	print "                    <freespace>  -> How much space should be freed\n";
	print "                    <volume>     -> Take this volume for free space calculation\n";
	print "                                    (the path where the volume is mounted - the last block in df !)\n";
	print "                    <dir>        -> dir inside which should be looked for dirs to del\n";
	print "                    [dir2...]    -> additional dirs\n\n";
	print "                    ATTENTION: freespace is only calculated on <volume>. if <dir>, [dir2...] are\n";
	print "                               on another volume u might loose all the data inside them !!\n\n";
	print "                    PS: There's a bonus-system included inside this script - edit it to fit your needs =)\n";
}

$space = shift @ARGV;
$volume = shift @ARGV;

foreach $dir (@ARGV) {
	opendir DIR, $dir;
	while($subdir = readdir(DIR))
	{
		if($subdir =~ /^\..*/) {
			next;
		}
		($dummy, $dummy, $dummy, $dummy, $dummy, $dummy, $dummy, $dummy, $dummy, $dummy, $time)=(stat ("$dir/$subdir"));
		if($bonus{$dir}) {
			if($debug >= 2) { print "(II) giving bonus of $bonus{$dir} days\n"; }
			$time=$time+($bonus{$dir}*86400);
		}
		if($subdir =~ /NUKED/i) {
			if($debug >= 2) { print "(II) giving $nukesfee days fee for nuked rel\n"; }
			$time=$time+($nukesfee*86400);
		}
		if($debug >= 2) { print "(II) $subdir -> $time\n"; }
		$dirstodel{$time} = "$dir/$subdir";
	}
	closedir(DIR);
}
# announce stuff
open(FORMATFILE, "< $formatfile") or die "ERROR: $formatfile not found.\n";
$format = <FORMATFILE>;
close(FORMATFILE);

foreach $time (sort (keys %dirstodel)) {
	$df = `df -m | grep '$volume\$'`;
	$df =~ /^\S+\s+\d+\s+\d+\s+(\d+)\s+\d+%\s+\S+$/;
	if($debug) { printf "(II) Freespace: $volume -> $1\n"; }
	if($1 > $space) {
		last;
	}
	else {
		$du = `du -sm '$dirstodel{$time}'`;
		$du =~ /^(\d+)\s+\S+$/ and $size = $1;
		$dirstodel{$time} =~ /^\S+\/(\S+)\/\S+$/ and $parentdir = $1;
		$dirstodel{$time} =~ /^\S+\/(\S+)$/ and $deleteddir = $1;
		@rules = (
			[ '$sitename'		, "$sitename"			],
			[ '$parentdir'		, "$parentdir"			],
			[ '$size'		, "$size"			],
			[ '$deleteddir'		, "$deleteddir"			]
		);
		if ($announcefile & $botpidfile) {
			announce_line($announcefile, $botpidfile, substitute($format,0,@rules));
		}
		if ($debug) { print "(**) Deleting $dirstodel{$time}\n"; }
		if ($debug >= 3) {
			print substitute($format,0,@rules);
		}
		`rm -Rf '$dirstodel{$time}'`;
	}
}
