##############################################################################
#                                                                            #
#  aviinfo v1.0 (c) 2002 Pedro                                               #
#                                                                            #
# ---------------------------------------------------------------------------#
#                                                                            #
#  This program is free software; you can redistribute it and/or modify      #
#  it under the terms of the GNU General Public License as published by      #
#  the Free Software Foundation; either version 2 of the License, or         #
#  (at your option) any later version.                                       #
#                                                                            #
##############################################################################

package aviinfo;
require Exporter;

use vars qw (@ISA @EXPORT);
use strict;
@ISA         = qw(Exporter);
@EXPORT      = qw(aviinfo);

sub aviinfo {
    my $fh = shift;
    my %aviinfo;
    my $type;
    
    open AVI, "< $fh";
    sysread(AVI,$type,12) or return"ERROR";
    my $header = undef;

    while (!$header) {
	my $data;
	sysread(AVI,$data,8) or die $!;
	if (substr($data,0,4) eq 'LIST') {
    	    sysread(AVI,$data,4) or die "Error\n";
	    if (substr($data,0,4) eq 'hdrl') {
		sysread(AVI,$header,10240);
	    }
	}
	close AVI;

	my $tag = 0;
	for (my $i=0; $i < length($header); $i++) {
	    my $t = $i;
	    my $window = substr($header,$t,4);
	    if ($window eq 'strh') {
    		$t += 8;
    		$window = substr($header,$t,4);
		if ($window eq 'vids') {
		    $aviinfo{scale} = (unpack("V",substr($header,$t+20,4)));
	    	    $aviinfo{v_rate} = (unpack("V",substr($header,$t+24,4)));
	    	    $aviinfo{fps} = ($aviinfo{v_rate} / $aviinfo{scale});
	    	    $aviinfo{v_frames} = (unpack("V",substr($header,$t+32,4)));
	    	    $aviinfo{v_streams} = (($aviinfo{v_streams} || 0) + 1);
	    	    $aviinfo{duration} = ($aviinfo{v_frames} / $aviinfo{fps}) if $aviinfo{fps};
            	    $tag = 1;
    		} elsif($window eq 'auds') {
		    $aviinfo{a_streams} = (($aviinfo{a_streams} || 0) + 1);
	    	    $tag = 2;
   		}
	    } elsif ($window eq 'strf') {
    		$t += 8;
    		$window = substr($header,$t,4);
    		if ($tag == 1) {
		    $aviinfo{width} = (unpack("V",substr($header,$t+4,4)));
		    $aviinfo{height} = (unpack("V",substr($header,$t+8,4)));
		    $aviinfo{v_codec} = (substr($header,$t+16,4));
		} elsif( $tag == 2 ) {
		    $aviinfo{a_codec} = (unpack("v",substr($header,$t,2)));
		    $aviinfo{a_chans} = (unpack("v",substr($header,$t+2,2)));
		    $aviinfo{a_rate} = (8 * unpack("V",substr($header,$t+8,4)));
		}
		$tag = 0;
	    }
	}    
    }
    return (%aviinfo);
}
