#!/usr/bin/perl -w 

##############################################################################
#                                                                            #
#  OpenFTPD Sitebot script v1.0 - (c) 2000 topace                            #
#                                                                            #
# ---------------------------------------------------------------------------#
#                                                                            #
#  This program is free software; you can redistribute it and/or modify      #
#  it under the terms of the GNU General Public License as published by      #
#  the Free Software Foundation; either version 2 of the License, or         #
#  (at your option) any later version.                                       #
#                                                                            #
##############################################################################

# Specify these three variables if you want to change anything
my $DEFAULTDIRSTOSHOW = 3;
my $MAXDIRSTOSHOW     = 10;
my $SHOWCOLORS        = 1;

############ SHOULDNT HAVE TO CHANGE ANYTHING PAST HERE ##################
use strict; #always
use FindBin;
use lib "$FindBin::Bin/";
use File::Basename;
use primetools;

# Shared vars
our ($counter,$username,$groupname,$ontime,$acttime,$activity,$path,$speed,$totalul,
     $totaldl,$bytesdown,$bytesup,$tagline, $someothernumber);

# This should locate your standarddir, either from F4A_STD or ~/.openftpdrc
if (exists $ENV{'F4A_STD'}) {
  my $standarddir = $ENV{'F4A_STD'};
}
elsif ( -e "$ENV{'HOME'}/.openftpdrc" ) {
  $standarddir = `cat $ENV{'HOME'}/.openftpdrc`;
  $standarddir =~ s/\n//;
  $standarddir =~ s/\r//;
}
else {
  print "ERROR: Cant locate your standarddir either in Environment F4A_STD or in $ENV{'HOME'}/.openftpdrc\n";
  exit 1;
}

$ENV{'F4A_COLOR'}="c";
# And change these if need be, but they should be ok
my $registry     = $standarddir."/etc/ftpd.reg";
my $pidfile      = $standarddir."/var/ftpd.pid";
my $wholog       = $standarddir."/var/who.log";
my $directorylog = $standarddir."/var/log/directory.log";
my $sectioncfg   = $standarddir."/etc/sections.cfg";
my $request_file = $standarddir."/var/request";
my $locatedbbin  = $standarddir."/bin/locatedb.pl";
my $affils_file  = $standarddir."/msg/affils";

#ok, so this is the lazy coders way of doing it, so sue me
my $shortsitenamereg = `cat $registry |grep shortsitename`;
my $ftpbasedirreg    = `cat $registry |grep basedir`;
my ($bla,$shortsitename,$ftpbasedir);
($bla,$shortsitename)=split(/\s+/,$shortsitenamereg,2);
($bla,$ftpbasedir)=split(/\s+/,$ftpbasedirreg,2);
chomp($shortsitename);
chomp($ftpbasedir);
my $trigger="!".$shortsitename;

my $line;

# what dirs should i ignore on !site usage
my $usageignore="(PRiVATE|GROUPS|STAFF)";

# vars for nukestuff
my ($time, $section, $directory, $nuker, $nukergroup, $nukee, $nukeegroup, $files, $size, $totalsize, $factor, $reason, $nukemsg, $num, %nuketop, %nukertop);

############ DEFINATELY SHOULDNT HAVE TO CHANGE ANYTHING PAST HERE ##################

sub convertwho
{
 $_[0] =~ s/\n//g;
 $_[0] =~ s/\r//g;
 my ($returnstr,$str);

 my @parts = split(/(%W\[(?:\w|:|-|%|\.)+\]\w)/, $_[0]);
 foreach my $p (@parts) {
   if ($p =~ /(%W\[((?:\w|:|-|%|\.)+)\](\w))/) 
   {
     if ( "$3" eq "C" ) {
      $returnstr=$returnstr.sprintf($2,$counter);
     }
     elsif ( "$3" eq "N" ) {
      $returnstr=$returnstr.sprintf($2,$username);
     }
     elsif ( "$3" eq "G" ) {
      $returnstr=$returnstr.sprintf($2,$groupname);
     }
     elsif ( "$3" eq "W" ) {
      $str=$username."@".$groupname;
      $returnstr=$returnstr.sprintf($2,$str);
     }
     elsif ( "$3" eq "T" ) {
      $returnstr=$returnstr.$ontime;
     }
     elsif ( "$3" eq "t" ) {
      $returnstr=$returnstr.$acttime;
     }
     elsif ( "$3" eq "A" ) {
      $returnstr=$returnstr.sprintf($2,$activity);
     }
     elsif ( "$3" eq "P" ) {
      $returnstr=$returnstr.sprintf($2,$path);
     }
     elsif ( "$3" eq "s" ) {
      $returnstr=$returnstr.sprintf($2,($speed/1024));
     }
     elsif ( "$3" eq "U" ) {
      $returnstr=$returnstr.sprintf($2,($totalul/1024));
     }
     elsif ( "$3" eq "D" ) {
      $returnstr=$returnstr.sprintf($2,($totaldl/1024));
     }
     elsif ( "$3" eq "S" ) {
      $returnstr=$returnstr.sprintf($2,(($totaldl+$totalul)/1024));
     }
     elsif ( "$3" eq "M" ) {
      $returnstr=$returnstr.sprintf($2,($bytesdown/1048576));
     }
     elsif ( "$3" eq "m" ) {
      $returnstr=$returnstr.sprintf($2,($bytesup/1048576));
     }
     else {
      $returnstr=$returnstr."{$2}{$3}";
     }
   }
   else {
     $returnstr=$returnstr.$p;
   }
 }

 return $returnstr;
}

# open up the pidfile
open (PIDFILE, "< $pidfile") or die "cant open pid file";
chomp (my $pid=<PIDFILE>);
close(PIDFILE);

# kill the ftpd, to get the latest who.log
kill ('USR2', $pid); 
sleep(2);

# open up the who.log, and push int into the hash
open (WHOFILE, "< $wholog") or die "cant open who.log";
my @who;
while (<WHOFILE>) 
{
  chomp($_);
  if($_) {push(@who, $_); }
}

#grab all the options from the command line
my ($where,$what,$option1,$option2,$option3);

($where,$what,$option1,$option2,$option3) = split(/\s+/,$ARGV[0],5);
$what = lc($what);
# make sure that options are initialized
if(!$option1) {
	$option1=" ";
}
if(!$option2) {
	$option2=" ";
}
if(!$option3) {
	$option3=" ";
}


# now the fun stuff

#
# WHO Command for the ANYWHERE #
#
if($what eq "who") {
  printf("\[\002%s\002:\002%s\002]-",$shortsitename,uc($what));
  foreach $line (@who) {
   ($username, $groupname, $ontime, $acttime, $bytesdown, $bytesup, $activity, $speed, $path, $tagline, $someothernumber) = split(/\t+/,$line,12);
   $activity =~ s/DOWNLOAD/DL/;
   $activity =~ s/UPLOAD/UL/;
   if($speed eq 0) {
     printf("[\002%s\002: %s] ",$username,$activity);
   }
   else {
     printf("[\002%s\002: %s at \002%2.1dkb/s\002] ",$username,$activity,$speed/1024);
   }
  }
}

#
# STATS Command for MESSAGE #
#
elsif($what eq "stats" && $where eq "msg") {
  my @statsoutput;
  
  @statsoutput=`$standarddir/bin/stats.pl $option1 $option2 $option3`;
  foreach $line (@statsoutput) {
    printf("%s",convertcolors($line));
  }
}

#
# STATS Command for CHANNEL #
#
elsif($what eq "stats" && $where eq "chan") {
  print "Sorry, stats are only available by messaging the bot";
}

#
# USER Command for ANYWHERE #
#
elsif($what eq "user") {
  printf("\[\002%s\002:\002%s\002]-",$shortsitename,uc($what));
  my $match=0;
  foreach $line (@who) {
   my ($username, $groupname, $ontime, $acttime, $bytesup, $bytesdown, $activity, $speed, $path, $tagline, $someothernumber) = split(/\t+/,$line,12);
   $activity =~ s/DOWNLOAD/DL/;
   $activity =~ s/UPLOAD/UL/;
   if(uc($option1) eq uc($username)) {
     $match=1;
     if($speed eq 0) {
       printf("[%s/%s: \002UL\002:%dmb \002DL\002:%dmb \002OnTime\002 :%s \002Current\002: %s] ",$username,$groupname,$bytesup/1048576,$bytesdown/1048576,$ontime,$activity);
     }
     else {
       printf("[%s/%s: \002UL\002:%dmb \002DL\002:%dmb \002OnTime\002 :%s \002Current\002: %s at \002%2.1dkb/s\002] ",$username,$groupname,$bytesup/1048576,$bytesdown/1048576,$ontime,$activity,$speed/1024);
     }
   }
  }
  if($match eq 0) {
    printf("\[\002%s\002 is not online]",$option1);
  }
}

#
# BANDWIDTH Command for ANYWHERE #
#
elsif(($what eq "bandwidth")||($what eq "bw")) {
  printf("\[\002%s\002:\002%s\002]-",$shortsitename,uc($what));
  my $countup=0;
  my $totalup=0;
  my $countdown=0;
  my $totaldown=0;

  foreach $line (@who) {
   my ($username, $groupname, $ontime, $acttime, $bytesdown, $bytesup, $activity, $speed, $path, $tagline, $someothernumber) = split(/\t+/,$line,12);
   if($activity =~ /UL:/) {
     $countup++;
     $totalup+=$speed;
   }
   if($activity =~ /DL:/) {
     $countdown++;
     $totaldown+=$speed;
   }
 }
 my $totalbandwidth=$totalup+$totaldown;

 printf("[\002%d\002 UPLOADS at \002%1.1dkb/s\002 -- \002%d\002 DOWNLOADS at \002%1.1dkb/s\002 -- TOTAL \002%1.1dkb/s\002]",$countup, $totalup/1024, $countdown, $totaldown/1024, $totalbandwidth/1024);

} 

#
# REQUESTS Command for ANYWHERE #
#
elsif(($what eq "requests")||($what eq "reqs")) {
	my ($NUMBERTOSHOW);
	my ($count, $timestamp, $forusername, $forgroupname, $request, $dummy);
	if($option1 ne " ") {
		if($option1 > $MAXDIRSTOSHOW ) {
			$NUMBERTOSHOW=$MAXDIRSTOSHOW;
		}
		else {
			$NUMBERTOSHOW=$option1;
		}
	}
	else {
		$NUMBERTOSHOW = $DEFAULTDIRSTOSHOW;
	}
 
	$count=1;
	printf("\[\002%s\002:\002%s\002]-",$shortsitename,uc($what));
	if (-s $request_file) {
		if (open (REQFILE, "< $request_file")) {
			while (($count<=$NUMBERTOSHOW) and ($dummy=<REQFILE>)) {
				chomp($dummy);
				($timestamp, $forusername, $forgroupname, $request) = split(/\s+/, $dummy, 4);
				print "[$count. \002$request\002 ($forusername/$forgroupname)] ";
				$count++;
			}
			close(REQFILE);
		}
	}
} 



#
# NUKETOP/NUKERTOP Command
#
elsif(($what eq "nuketop")||($what eq "nukertop")) {
	$nukemsg=sprintf("\[\002%s\002:\002%s\002] ",$shortsitename,uc($what));
	open(NUKELOG, "< $standarddir/var/log/nukes.log") or die "Can't open nukelog!\n";
	while(<NUKELOG>) {
		chop($_);
		($time, $section, $directory, $nuker, $nukergroup, $nukee, $nukeegroup, $files, $size, $totalsize, $factor, $reason)=split(";",$_);
		if(exists $nuketop{$nukee}) {
			$nuketop{$nukee}{'size'}+=$size;
			$nuketop{$nukee}{'files'}+=$files;
		}
		else {
			$nuketop{$nukee}{'size'}=$size;
			$nuketop{$nukee}{'files'}=$files;
		}
		if(exists $nukertop{$nuker}) {
			$nukertop{$nuker}{'size'}+=$size;
			$nukertop{$nuker}{'files'}+=$files;
		}
		else {
			$nukertop{$nuker}{'size'}=$size;
			$nukertop{$nuker}{'files'}=$files;
		}
	}
	close(NUKELOG);
	$num=0;
	if($option1 eq " ") {
		$option1=$DEFAULTDIRSTOSHOW;
	}
	if($what eq "nuketop") {
		foreach $line (sort {$nuketop{$b}{'size'} <=> $nuketop{$a}{'size'}}(keys %nuketop)) {
			$nukemsg.="[ Nukee #".++$num.": \002$line\002 Files: \002$nuketop{$line}{'files'}\002 Size: \002". filesize_to_string($nuketop{$line}{'size'})."\002 ] "; 
			if($num==$option1) {
				last;
			}
		}
	}
	else {
		foreach $line (sort {$nuketop{$b}{'size'} <=> $nuketop{$a}{'size'}}(keys %nukertop)) {
			$nukemsg.="[ Nuker #".++$num.": \002$line\002 Files: \002$nukertop{$line}{'files'}\002 Size: \002". filesize_to_string($nukertop{$line}{'size'})."\002 ] ";
			if($num==$option1) {
				last;
			}
		}
	}
	printf("$nukemsg\n");
}
#
# NEW Command for ANYWHERE #
#
elsif($what eq "new" && $where eq "chan") {
  my $NUMBERTOSHOW;

  printf("\[\002%s\002:\002%s\002]-",$shortsitename,uc($what));
  if($option2 ne " ") {
    if($option2 > $MAXDIRSTOSHOW ) {
      $NUMBERTOSHOW=$MAXDIRSTOSHOW;
    }
    else
    {
      $NUMBERTOSHOW=$option2;
    }
  }
  else {
    $NUMBERTOSHOW = $DEFAULTDIRSTOSHOW;
  }
  my $x=0;
  my $finalstr;
  my @dirlog;
  open (DIRLOG, "< $directorylog") or die "cant open directorylog";
  while (<DIRLOG>)
  {
    chomp($_);
    if($_) {
      if($_ !~ /[Cc][Dd][0-9]/ && $_ !~ /(sample|sbc-stats|stats$|ac3-codec)/i ) {
         push(@dirlog, $_); }
      }
  }
  close(DIRLOG);
  $option1=uc($option1);

  while($x < $NUMBERTOSHOW) {
     my $last=pop(@dirlog);
     if(!$last) {
       $x=$NUMBERTOSHOW;
       next;
     }
     my ($date, $time, $username, $groupname, $section, $path) = split(/\s+/,$last,6);
     if($option1 ne " " and $option1 ne "ALL") {
       if(uc($section) eq $option1) {
         $x++;
         $finalstr=$finalstr . " \[\002$x.\002 " . basename($path) . "]";
       }
     }
     else {
       $x++;
       $finalstr=$finalstr . " \[\002$x.\002 " . basename($path) . "]";
     }
  }
  if(!$finalstr) {
    print ("NO releases in section: $option1");
  }
  else {
	if($option1 eq " ") {
		$option1="ALL";
	}
	printf("\[\002%s\002]-%s",$option1,$finalstr);
	$x++;
  }
}

#
# NEW Command for MESSAGE #
#
elsif($what eq "new" && $where eq "msg") {
  my @statsoutput=`$standarddir/bin/lastdirs.pl $option1 $option2 $option3`;
  foreach $line (@statsoutput) {
    printf("%s",convertcolors($line));
  }
}

#
# USAGE Command for ANYWHERE #
#
elsif($what eq "usage") {
	my ($usage, $sec, @sections);
	my ($secname,$seccfg,$secstat,$secpath);
  
	printf("\[\002%s\002:\002%s\002]-",$shortsitename,uc($what));

# now open the sections.cfg file, and grab all the path names of active sections
	open(SECCFG,"< $sectioncfg") or die "ERROR: unable to open sectioncfg";
	while(<SECCFG>) {
		if($_ !~ /[#].*/) {
			chomp($_);
			push(@sections,$_);
		}
	}
	close(SECCFG);
	foreach my $sec (@sections) {
		($secname,$seccfg,$secstat,$secpath) = split(/\s+/,$sec,4);
		if($secpath=~/$usageignore/) {
			next;
		}
		$usage=`du -sk $ftpbasedir$secpath`;
		($usage)=($usage=~/^(\d+)\s+.*/);
		if($usage>1024) {
			$usage=int $usage/1024;
			print "[$secpath: \002$usage\002 MB] ";
		}
		else {
			print "[$secpath: \002$usage\002 KB] ";
		}
	}
	print "\n";
}

#
# DF Command for ANYWHERE #
#
elsif($what eq "df") {
  printf("\[\002%s\002:\002%s\002]-",$shortsitename,uc($what));

  #If you use linux, use these lines.
  my $df=`df -m`;
  my $dfbase=`df -m $ftpbasedir`;

#  if you use OpenBSD, use these lines
#  $df=`df -h`;
#  $dfbase=`df -h $ftpbasedir`;

  my @baselines = split(/\n/, $dfbase);
  my ($dev,$total,$used,$free,$percent,$where)=split(/\s+/,$baselines[1],6);
  my $basefree=$free;

# now open the sections.cfg file, and grab all the path names of active sections
  my @sections;
  open(SECCFG,"< $sectioncfg") or
     die "ERROR: unable to open sectioncfg";
  while(<SECCFG>) {
    if($_ =~ /[#].*/) {
      #ignore cuz its a comment
    }
    else
    {
      chomp($_);
      push(@sections,$_);
    }
  }
  close(SECCFG);

  my @lines = split(/\n/, $df);
  my $outstr;
  foreach my $sec (@sections) {
     my ($secname,$seccfg,$secstat,$secpath) = split(/\s+/,$sec,4);
     my $matched=0;
     foreach $line (@lines) {
       ($dev,$total,$used,$free,$percent,$where)=split(/\s+/,$line,6);
       if($where =~ /$secpath/) {
          $outstr = $outstr . "\[$secname: \002$free\002 MB] ";
          $matched=1;
       }
     }
     if($matched eq 0) {
       $outstr = $outstr . "\[$secname: \002$basefree\002 MB] ";
     }
  }
  print "$outstr";
}

#
# SEARCH Command for CHAN #
#
elsif($what eq "search" && $where eq "chan") {
  printf(" Use  \002$trigger SEARCH\002 in a \002MESSAGE\002 window to find dirs ");
}

#
# SEARCH Command for MSG #
#
elsif($what eq "search" && $where eq "msg") {
	my ($dummy, $command, @result);

	print "---------------------------------------------------------------------------\n"; 
	print " $shortsitename SEARCH for $option1 - OpenFTPD Sitebot\n";
	print "---------------------------------------------------------------------------\n"; 
	$command = $locatedbbin;
	if($option1 ne " ") {
		$command .= " $option1";
		if($option2 ne " ") {
			$command .= " $option2";
		}
		@result=`$command`;
		foreach $dummy (@result) {
			print ("$dummy");
		}
	}
	else {
		print ("\002USAGE\002: $shortsitename search <SEARCHSTRING> [SECTION]");
	}
}

#
# BNC Command #
#
elsif($what eq "bnc") {
	my ($dummy, @result);

	@result=`$standarddir/bin/bnctest.pl`;
	foreach $dummy (@result) {
		print $dummy;
	}
}

#
# AFFILS Command for CHAN #
#
elsif($what eq "affils") {
	if (-f $affils_file) {
		open (AFFILFILE, "<$affils_file");
		while(<AFFILFILE>) {
			print $_;
		}
		close AFFILFILE;
	}
	else {
		print "Affils file not found error\n";
	}
}

#
# HELP Command for CHAN #
#
elsif($what eq "help" && $where eq "chan") {
  printf(" Use  \002$trigger HELP\002 in a \002MESSAGE\002 window for HELP ");
}

#
# HELP Command for MSG #
# This is ugly, but I dont have the time to make the output look "pretty" :( 
elsif($what eq "help" && $where eq "msg") {
  print "---------------------------------------------------------------------------\n"; 
  print " $shortsitename HELP - OpenFTPD Sitebot\n";
  print "---------------------------------------------------------------------------\n"; 
  print " Command                          Description\n";
  print "---------------------------------------------------------------------------\n"; 
  print " HELP                             This help\n";
  print " WHO                              WHO is online\n";
  print " AFFILS                           list affils\n";
  print " DF                               Disk usage information for each section\n";
  print " BNC                              Shows BNC-Status\n";
  print " USAGE                            Shows discusage of sections\n";
  print " BANDWIDTH or BW                  Current site bandwidth usage\n";
  print " NUKETOP [NUMBER]                 Display NUMBER topnukees\n";
  print " NUKERTOP [NUMBER]                Display NUMBER topnukers\n";
  print " NEW [SECTION] [NUMBER]           NUMBER New Directories in SECTION\n";
  print " USER <USERNAME>                  Information about USERNAME\n";
  print " REQUESTS [NUM] or REQS [NUM]     Shows current requests (request 1 to NUM)\n";
  print " SEARCH <WHAT> [SECTION]          Search for dirs on your ftp\n";
  print " STATS <WHAT> [SECTION] [NUMBER]  NUMBER lines of stats from SECTION,\n";
  print "                                  WHAT is defined as <u|g><d|w|m|y|t><u|d>\n";
  print "---------------------------------------------------------------------------\n"; 
  print " Sections: ";

  open(SECCFG,"< $sectioncfg") or
     die "ERROR: unable to open sectioncfg";
  while(<SECCFG>) {
    if($_ =~ /[#].*/) {
      #ignore cuz its a comment
    }
    else
    {
      chomp($_);
      my ($secname,$seccfg,$secstat,$secpath) = split(/\s+/,$_,4);
      print "$secname ";
    }
  }
  close(SECCFG);
  print "\n";
  print "---------------------------------------------------------------------------\n"; 

}
elsif($what eq "test") {
# forground color codes
#   printf(" FORGROUND COLOURS: \0030 0030 \0031 0031 \0032 0032 \0033 0033 \0034 0034 \0035 0035 \0036 0036 \0037 0037 \0038 0038 \0039 0039 \00310 00310 \00311 00311 \00312 00312 \00313 00313 \00314 0314 \00315 00315 \00313 00316\n");
   printf(" BACKGROUND COLOURS: \003,0 003,0 \003,1 003,1 \003,2 003,2 \003,3 003,3 \003,4 003,4 \003,5 003,5 \003,6 003,6 \003,7 003,7 \003,8 003,7 \003,9 003,9 \003,10 003,10 \003,11 003,11 \003,12 003,12 \003,13 003,13 \003,14 003,14 \003,15 003,15 \003,16 003,16");
}
else {
  printf("\[\002%s\002:\002%s\002]-",$shortsitename,uc($what));
  print "Unrecognized Command, usage: $trigger <command>   try \002help\002 as a command to list all commands\n";
}

