#!/usr/bin/perl

use strict;

my $standarddir;

if (exists $ENV{'F4A_STD'}) {
	$standarddir = $ENV{'F4A_STD'};
}
elsif ( -e "$ENV{'HOME'}/.openftpdrc" ) {
	$standarddir = `cat $ENV{'HOME'}/.openftpdrc`;
	$standarddir =~ s/\n//;
	$standarddir =~ s/\r//;
}
else {
	print "ERROR: Cant locate your standarddir either in Environment F4A_STD or in $ENV{'HOME'}/.openftpdrc\n";
	exit 1;
}

# change these vars to fit your needs

# where to store the database
my $database = $standarddir."/var/locatedb.txt";
# where to find your sections.cfg
my $sectioncfg = $standarddir."/etc/sections.cfg";
# dirs which should be ignored
my $ignoredirs = "(cd[1-9]|disc[0-9]|sample|stats|sbc-stats|stats-file|ac3-codec|-complete-)";
# enter the directory of your ftp-root - f.e. /home/openftpd/site
my $ftprootpath = $standarddir."site";
# enter the sections u want to be scanned (1st column in sections.cfg)
my $sections = "APPZ DiVX-DEU DiVX-ENG GAMEZ LiNUX REQUEST SERiES VCD";

my ($dummy, @find);
my ($secname, $seccfg, $secstat, $secpath);

open(LOCATE,"> $database") or die "ERROR: unable to open database";
open(SECCFG,"< $sectioncfg") or die "ERROR: unable to open sectioncfg";
while(<SECCFG>) {
	if($_ !~ /[#].*/) { 
		chomp($_);
		($secname,$seccfg,$secstat,$secpath) = split(/\s+/,$_,4);
		if ($sections !~ /$secname/i) {
			next;
		}
		$secpath=~s/^\///;
		@find=`cd $ftprootpath; find $secpath -type d | egrep -vi "$ignoredirs"`;
		foreach $dummy (@find) {
			chomp ($dummy);
			if ($dummy =~ /^$secpath$/i) {
				next;
			}
			print LOCATE "$dummy\n";
		}
	}
}
close(SECCFG);
close(LOCATE);
print "Done\n";
