#!/usr/bin/perl -w

#############################################################################
#                                                                           #
#  weektop.pl V0.1 - generate and announce weektops (c) by FEJF 2002        #
#                                                                           #
#  fejf@gmx.de                                             www.openftpd.org #
#                                                                           #
# --------------------------------------------------------------------------#
#                                                                           #
#  This program is free software; you can redistribute it and/or modify     #
#  it under the terms of the GNU General Public License as published by     #
#  the Free Software Foundation; either version 2 of the License, or        #
#  (at your option) any later version.                                      #
#                                                                           #
#############################################################################

### TODO

use strict;

########################################
# set these vars to suit your needs ;) #
########################################

# be verbose
my $debug        = 1;

# vars for announces
my $sitename     = "ABC";
my $botpidfile   = "/home/openftpd/etc/pid.eggdrop";
my $announcefile = "/home/openftpd/etc/announce.txt";
my $ftpdpidfile  = "/home/openftpd/var/ftpd.pid";

# where to get the stats from
my $stats        = "/home/openftpd/bin/stats.pl";

########################################

my ($pid, $section, $message, $dummy, $line, @output);

$pid = `cat $ftpdpidfile`;
`kill -USR1 $pid`;

if($ARGV[0]) {
	$section=$ARGV[0];
}
else {
	$section="GLOBAL";
}

if ($section =~ /MP3/) {
	$message = "[\002jS\002] -WEEKTOP:MP3- ";
}
else {
	$message = "[\002jS\002] -WEEKTOP:$section- ";
}
$dummy=1;
@output=`$stats uwu $section`;
foreach $line (@output) {
	if($debug) { print "(II) $line"; }
	if($line !~ /.*\d\d\s(\S+)\s+(\S+)\s+.*\s+(\d+) MB.*/) {
		next;
	}
	if($debug) { print "(II)  -> $1: $3MB\n"; }
	$message .= "$dummy. \002$1\002: $3 MB ";
	$dummy++;
}
if ($section =~ /MP3/) {
	$message .= "\n[\002jS\002] -WEEKTOP:MP3- ";
}
else {
	$message .= "\n[\002jS\002] -WEEKTOP:$section- ";
}
$dummy=1;
@output=`$stats gwu $section`;
foreach $line (@output) {
	if($line !~ /.*\d\d\s(\S+)\s+.*\s+(\d+) MB\s+.*/) {
		next;
	}
	$message .= "$dummy. \002$1\002: $2 MB ";
	$dummy++;
}
$message .= "\n";

if ($debug) { print "$message\n"; }
`echo "$message" >> $announcefile`;
$pid = `cat $botpidfile`;
`kill -HUP $pid`;
